> 本文由 [简悦 SimpRead](http://ksria.com/simpread/) 转码， 原文地址 [mp.weixin.qq.com](https://mp.weixin.qq.com/s/d8h8ti2S_qjW11uGoXNi1g)

娜璋 AI 安全之家于 2020 年 8 月 18 日开通，将专注于 Python 和安全技术，主要分享 Web 渗透、系统安全、CVE 复现、威胁情报分析、人工智能、大数据分析、恶意代码检测等文章。真心想把自己近十年的所学所做所感分享出来，与大家一起进步。

系统安全系列作者将深入研究恶意样本分析、逆向分析、攻防实战等，通过在线笔记和实践操作的形式分享与博友们学习。前文讲解了 OllyDbg 和 Cheat Engine 工具逆向分析用法，完成植物大战僵尸的游戏辅助器，包括修改阳光值和自动拾取阳光两个功能。这篇文章将继续带领大家来学习科锐钱林松老师的视频，详细讲解条件语句和循环语句源码还原及流程控制逆向。话不多说，让我们开始新的征程吧！希望对入门的同学有帮助，作者的目的是与安全人共同进步，加油！也强烈推荐大家去看看钱老师的视频和书籍。

文章目录：

*   一. C++ 逆向条件结构基础入门  
    1. 单分支结构分析  
    2. 双分支结构分析
    
*   二. C++ 逆向循环结构基础入门  
    1.do-while 结构分析  
    2.while 结构分析  
    3.for 结构分析
    

> 声明：本人坚决反对利用教学方法进行犯罪的行为，一切犯罪行为必将受到严惩，绿色网络需要我们共同维护，更推荐大家了解它们背后的原理，更好地进行防护。参考文献见后，github 资源如下：
> 
> - https://github.com/eastmountyxz/Reverse-Analysis-Case

一. C++ 逆向条件结构基础
===============

大家写过相关的算法吗？  
加密代码中会涉及循环和分支，你要识别算法，首先就是需要将它的算法处理流程识别出来。当我们还原出等价的高级代码之后，就没有逆向分析人员的事情了，因为接下来涉及到密码学、数学相关人员的工作，逆向人员把加密的代码还原出来后就应该扔给研究密码学的数学家，他们负责玩数学对抗，而逆向关注的是编译原理和代码还原。同时，逆向还涵盖了识别对象、识别算法、识别优化、识别虚函数对象的继承关系等等，这里主要结合项目相关的加密和解密进行讲解。接着作者准备穿插着 VC++6.0 和 VS2019 两个版本进行讲解。

1. 单分支结构分析
----------

第一步，通过 VC++6.0 编写一个最简单的程序，创建工程名称为 “RE_SF”。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz5oKFB3LibQjib4U05kpRwuicTcMVTpTq0buKXo25YDszbY9ibHIicefqfXQ/640?wx_fmt=png)  
![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzcI1Ly1WuIZ5uWp9oAXCtWaqzldF1Ay9pUL8cQdcJUfBqfwF7RZWgNA/640?wx_fmt=png)

运行结果如下图所示，可以看到 “Hello World”。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzqvQaaj5XhzJcVhZQ8icfkAWjmYMPScriccaay7jV0fX9iaVvzkTh0fiacw/640?wx_fmt=png)

第二步，编写单分支结构的相关代码。

```
#include "stdafx.h"int main(int argc, char* argv[]){	if (argc > 8 )	{		printf("argc > 8\r\n");	}	return 0;}
```

接着选择 “Win32 Release” 编译运行代码。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz78ic0X1icAnpomOpPP53Xq0fm3BFbbBSHiaGfht3ibXeWYo0TJBRURiaVsQ/640?wx_fmt=png)

第三步，接着用 OD 软件打开 EXE 文件。  
此时创建的工程目录分布如下图所示。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzdVOc3DAmCF6iaHRVlVfOlH8Z53IGHtJC4qAxlpatjyIYicjPqfoxzL5Q/640?wx_fmt=png)

OllyDbg 打开之后显示如下图所示的界面，程序入口地址是 0x00401051。

*   程序入口：0x00401051
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzZEXibUGyP0TZ1pZMg2lrliaNSTJJ41CEbUbZnG8skHLtC52KLNALrkIg/640?wx_fmt=png)

第四步，首先我们需要定位 main 函数，其方法非常简单，找到有三个 PUSH 的下面就是 main 函数，因为 main 函数有三个参数（argc、argv[],、envp[]）。接着按 F2 下断点。

*   **主函数：0x00401100**
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz7SGBt5PR0crpXZHq6pjIbRfKmTEh4pRIYgibflo65d8eJg3VD742O8w/640?wx_fmt=png)

继续按下 F7 跟进，会看到一个单分支结构。那么，单分支结构它有什么特点呢？

*   进入主函数：0x00401000
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzicFKBNAxDVgvSqdI3DdaWm367C7m08xPIlAwC7jmGAGqBWxrb6UL0Kg/640?wx_fmt=png)

第五步，先给大家普及单分支语句的代码定式基础知识。  
在高级语言中单分支代码定式如下：

```
//程序语言if(...){    ...}//代码定式IF_BEGIN:    jxx IF_END        ...    IF_END:        ...
```

为什么需要记住这个代码定式呢？  
因为对于流程控制的识别，我们关键是要找到 IF 语句的作用域（上界和下界），上界在 jxx 的位置，称之为 IF_BEGIN。接着有个 jxx 条件跳转，跳转到目标且没有其他的特征，这种就称之为单分支的代码定式。

回到我们的汇编代码，拿到这个代码之后，发现存在一个箭头指向跳转目标，这样就出现了 IF 模块的上界和下界，条件判断作为 IF 的上界，条件跳转的目标作为 IF 下界，通过这种套路方式来还原代码。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz0D2G7TcG28nPbvo9ib66iakFCGgtFwSNY87xKvsZIFstSgSU7D0c4g0g/640?wx_fmt=png)

第六步，分析嵌套的单分支语句。  
假设我们的判断中再嵌套一层或增加一个分支，又该怎么判断呢？对于我们还原代码的人来说，不用管它，你把上下界圈出来，然后递归解决。所有流程问题只要找到上下界，剩下的问题就变成了顺序结构，再看着代码一条条还原即可。  

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzDk8k9YkFiauOVj0hnzl1GQ25B0kWNaOmyHmHSUzicstgs8Bg02mdr9uA/640?wx_fmt=png)

```
#include "stdafx.h"#include <stdlib.h>int main(int argc, char* argv[]){	if (argc > 8 )	{		printf("argc > 8\r\n");		if (argc < 80)		{			printf("argc < 80\r\n");		}	}	system("pause");	return 0;}
```

接着运行程序生成新的 EXE 程序，然后通过 OD 软件打开分析，给主函数下个断点然后进入主函数显示如下图所示的界面。

*   主函数内容：0x00401000
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzv60b398IGSJYLIt8GgKV7vfIobAvoLic6icbzg8zibh3YTj31iaEPArHBQ/640?wx_fmt=png)

第七步，同样的方法将两层单分支语句的上下界圈出来。  
我们发现这两个判断的下界重合了，都是跳转到 0x00401029 位置，这就明显是个嵌套。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzpp181HxdhBUlsG0I8jq8zQus4L0RiaJAicibKeuFvveasxHuiaAb86OUBA/640?wx_fmt=png)

总结下 IF 语句的特点：

*   观察它的条件跳（上下界）
    
*   条件跳的目标上面的代码没有其他特征，即 “ADD ESP, 4"
    

那么，怎么还原出高级代码呢？

第八步，通过汇编代码还原出高级代码。  
还原代码需要进行反调节操作，并且学会查询相关指令。比如 JLE、JGE 是什么意思呢？

*   JLE（jump if less or equal,or not greater）：汇编语言中的条件转移指令，小于或等于则条件转移
    
*   JGE：大于或等于转移指令
    

注意，在还原的时候需要做反条件操作。那么，什么叫反条件呢？具体解释如下：

*   JLE：小于等于跳转 --> 代码还原就是 “不小于等于”，即：大于跳转
    
*   JGE：大于等于跳转 --> 代码还原就是 “不大于等于”，即：小于跳转
    

> **反条件**  
> 因为当我们满足这个条件的时候它会跳转到另一个地方（结束地方），它没有执行具体的代码；所以如果我们想要执行模块中的代码，就需要反条件处理。即汇编的语义和高级语言的语义是反的，高级语言的语义是满足条件则执行语句块，而汇编的语义是满足条件不执行语句块。

接着我们继续看触发跳转的代码，它是通过 CMP 比较来触发的。

*   CMP ESI, 8
    
    ESI 是通过参数传递过来的，然后和 8 进行不小于等于的比较
    
*   CMP ESI, 50
    

  
ESI 和 50 进行不大于等于的比较

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzHo2SDcEK21lShbu2NS8VwBasHb2Tuuuxibtgg9uhhfiaHMMsHt6l2SIA/640?wx_fmt=png)

此时，我们再将单分支步骤简单归纳如下：

*   (1) 通过反汇编代码序列，匹配代码定式；
    
*   (2) 如果是单分支 if 结果，则将条件转义指令 jxx 做反条件还原
    

第九步，接着我们换个工具用 VS2019 打开我们的代码，生成新的 Release 版本。  

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzb9vBZyx0pica1990XfibRfv3zeOsurlt0AWtWf28vKAI6MN2ywCDjFqg/640?wx_fmt=png)

然后删除本地的 Release 资源，生成一个新的 Release 方案。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzWa5Q8sg6VXibwF1zXYeyvWHTQqrDthBWNx0ZR9h71gNqXibrjkmYPDWA/640?wx_fmt=png)

第十步，用 IDA Pro 打开可执行 EXE 程序进行分析。  
同样，使用 IDA 也是可以进行逆向分析的，打开新生成的逆向分析工具如下所示。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzPJKZpRYtONNZfApnpQEhWF59MwfXWvl69gbz1FykPBZdVRd6CINicIw/640?wx_fmt=png)

右键选择 “Text View” 查看源代码。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDziaIpR4lnAARHBtNREOZiccGsyfy4ejAn8MC6Tjicw3e5OpTxiayAXW0c8w/640?wx_fmt=png)

找到 main 函数，然后点击 “_main” 位置高亮显示。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzjpz3orLticfdS6eg4h9vV9EJADeVI6jXPKrP4Ijq0SPjAzWeEZOmrRg/640?wx_fmt=png)

按下 “N” 键可以对函数进行重命名，如下图所示。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzIZsndibiaywuoosvSKRf1u7owDmPAg7RkrvbUic3m7EoYjTib3XSgBzEGw/640?wx_fmt=png)

注意，前面分享的识别方法和编译器版本、编程语言（C++、VB）等都没有关系，它是编译原理的问题。接着我们重点还是回归到代码上去，点击 “loc_401039” 函数高亮，同样的方法划分出这个单分支的上界和下界，并且嵌套了一个单分支，最终还原出源代码。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzvZUANR06UyJsupib5LRvOP0vyKFOVTmeZenkChWrZLFbuzvMFjEVlkA/640?wx_fmt=png)

所以，不论使用 VC++6.0 或 VS 编译工具，还是使用 IDA 或 OD 工具，它们还原代码的原理及方法都是一样的。在实际项目中，不论你用什么分析工具，最终能分析出结果就好。

2. 双分支结构分析
----------

第一步，编写双分支代码。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzEsJicuoQTMSH8pbYx6BL4Uow9TwZY47NtD8HG60KRaeiax1SADTLNVnQ/640?wx_fmt=png)

第二步，普及双分支语句的代码定式基础知识。  
在高级语言中双分支代码定式如下。该代码序列关键是发现 jxx 后，需要检查目标看看下面有没有一个 jmp 指令，如果有个 jmp 且是往下跳的，if-else 就成立了。

```
//程序语言if(...) {    ...}else {	...}//代码定式IF_BEGIN:jxx ELSE_BEGIN    ...IF_END:    jmp ELSE_ENDELSE_BEGIN:    ...ELSE_END:    ...
```

第三步，接着生成新的 exe 文件，用 OD 打开分析。  
同样的方法进入主函数，然后 F7 单步步入 0x00401000 位置，如下图所示。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz3rojIugElnWY6qtxK7P35eQbuFmFqRQGenFXgUt6dwn4SpGWMd6PHg/640?wx_fmt=png)

核心代码及其跳转如下图所示。

*   JLE --> 0x0040100E：PUSH 操作
    
*   JMP --> 0x00401013：CALL 操作
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzh6J4wwq0UmA44jEI8xH3eYVEaMoChcRWleb02LEz0s7VNxfAK6sz3g/640?wx_fmt=png)

双分支结构特点：  

*   jxx 的目标处上一行指令为 jmp，而且是往高地址去的 jmp（往下跳）。如果是循环，后面会讲到它可能往上跳。
    

确定上下界之后，生成如下图所示的 if 模块和 else 模块，同样的反条件处理还原代码。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzKWNynz9wEYMyoTicLQxFG8S6yXYAYx9f0DlWJTCrEsJvy03SmAYRZjQ/640?wx_fmt=png)

注意，这里有一个小小的优化，编译原理中的代码外提。它是什么意思呢？  
假设有个节点 A，现在有了流程分支 B1 和 B2，B1 完成后执行 C，B2 完成后也会执行 C。编译器为了减小代码的节点，因为代码节点越多，代码越长，就做了等价流程的代码外提优化，从而汇总到 C，少了一个节点。

*   编译器会视情况减少节点的优化
    
*   编译器也会增加节点来减小路径的优化
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzZJsPYc6kkeE7iagibNGFLBtkkpQpvhQVf7UWKe91n2jicvZecGo8AjLRA/640?wx_fmt=png)

第四步，采用同样的方法用 IDA 工具分析还原代码，其效果也一样。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzdRS5tUMvX5UZRE4SCEF2mTTGoCcVWw3u9mEt1KaThfEhPFq0zL4Gog/640?wx_fmt=png)

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzCDKkopahibMyMcJCEhDMaoMAib2EItzYlr1ic8uzUfur8jc6ibWhib26WDg/640?wx_fmt=png)

接着你可能会疑问这两个 PUSH 是干啥呢？**

*   push offset aArgc8 ; “argc> 8\r\n”
    
*   push offset aArgc8_0 ; “argc <= 8\r\n”
    

C 语言中没有标准的高级语法对应汇编中的 PUSH 操作，说明它有代码优化了，就是代码外提操作。它们有个公共的函数调用被提到下面去了，就是下图所示的两行代码，这个时候我们要把它放回去方便还原。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzskcWrjD5k6RqUZ9mR0naOaqOWAc0XhbEqInb2fdia2iaiaicEicnPSlOYqw/640?wx_fmt=png)

接着我们复制汇编代码至 C 语言中进行还原，方便大家理解。代码如下，此时增加了 if 和 else 的上下界，但发现两个 push 无法还原。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzDbCbesFkm0Mic2piceD7hFvtTicrqHwFlB4mfBzvxpBkjM0TMNic0OciczQ/640?wx_fmt=png)

同时将代码外提部分分别放到 if 和 else 模块中，就能实现最终代码还原，如下图所示。最后删除掉多余的汇编注释即可。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz3jwBqPdRMTNznW4HVRxgKgyNq8g6MOl0TicVAnNDFptw19jm2mzVumg/640?wx_fmt=png)

继续还原条件判断内容，JLE 小于等于换成大于 8 就好。在真实环境中，还会遇到双分支中有循环或条件嵌套的问题，不要担心，找到上下界继续分析即可。

```
#include "stdafx.h"#include <stdlib.h>int main(int argc, char* argv[]){//.text:00401000                 cmp     [esp+argc], 8//.text:00401005                 jle     short loc_40100E	if (argc > 8)	{//.text:00401007                 push    offset aArgc8   ; "argc > 8\r\n"//.text:0040100C                 jmp     short loc_401013//.text:00401013                 call    sub_4010C6		printf("argc > 8\r\n");//.text:00401018                 add     esp, 4	}//.text:0040100E ; ---------------------------------------------------------------------------//.text:0040100E	else	{//.text:0040100E loc_40100E:                             ; CODE XREF: _main+5↑j//.text:0040100E                 push    offset aArgc8_0 ; "argc <= 8\r\n"//.text:00401013                 call    sub_4010C6		printf("argc <= 8\r\n");//.text:00401018                 add     esp, 4	}//.text:00401013//.text:00401013 loc_401013:                             ; CODE XREF: _main+C↑j//.text:0040101B                 push    offset aPause   ; "pause"	system("pause");	return 0;}
```

二. C++ 逆向循环结构基础
===============

1.do-while 结构分析
---------------

循环包括 do-while、while 和 for 三种，你会觉得哪一种消息最高呢？do-while 是三种循环中效率最高的，由于其无条件先执行一次，所以大家很少使用，但其效率很高。

基本语法  
先执行，再判断。先执行一遍循环操作，若符合条件，循环操作继续执行，否则退出循环。

```
do{    循环操作语句;}whlie(循环条件);
```

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzxBbNibFUpicicfzSQrprkboP6xy35yh3KGULpQYTgy9keO1qwdONu9zjA/640?wx_fmt=png)第一步，我们编写一个 1 加到 100 的循环代码，这次直接使用 Debug 版本。

```
#include "stdafx.h"#include <stdlib.h>int main(int argc, char* argv[]){	int n = 1;	int nSum = 0;	//do-while 执行一次	do {		nSum = nSum + n;		n++;	} while(n <= 100);		printf("%d", nSum);	system("pause");	return 0;}
```

第二步，通过 OD 打开运行的 EXE 程序 “RE_XH.exe”。

*   程序入口地址：0x00401260
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzQ31LB1Nj5d8HgMWCibJp8LrgtX5MXAQPm5rIXJfJpPW9gSiaUtL7mMHA/640?wx_fmt=png)

第三步，往下查找代码，发现 3 个 PUSH 后（参数）就是主函数，然后 F2 添加断点并 F7 步入主函数。

*   主函数：CALL RE_XH.00401005
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzRGu0FwGczc2NbfjxYpkOqofykTic3DI4EhNEHxhicS4cKLVO0GgCxribw/640?wx_fmt=png)

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz5TqDHicpBePwzBEQw79gH4jDFO6MmTFicpicWY6cOt4NrrW6oSKCCygSw/640?wx_fmt=png)

第四步，分析汇编代码。  
这里存在一个 JLE 跳转，如果条件跳往上跳就是 do-while 循环。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzqmYRJAMymW36Cz6c8u0SWxh18ZQK1kbnKHczGI01RAfiaUq8hlz7yRw/640?wx_fmt=png)

循环肯定会往上走，否则构成不了循环，它需要反复执行同一代码段。如果跳转的目标没有检查条件，就是 do-while 循环。简单总结下识别 do-while 循环步骤：

*   识别代码定式
    
*   如果是 do 循环，则按 jxx 同条件还原等价高级代码
    

注意，同条件的就只有 do-while 结构。在 do-while 循环中，它跟汇编的语义是一样的，只有当条件满足则流程更新到循环的起始地点，所以它是正条件还原。而前面的 if-else 判断都是反条件。

```
//程序语言do{    ...}while(xxx);//代码定式DO_BEGIN:    ...    jxx DO_BEGINDO_END:    ...
```

2.while 结构分析
------------

基本语法  
先判断，再执行。

```
whlie(循环条件){    循环操作语句;}
```

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzqATPib1DP5TSapODdibY0tj7HrsZkQaVqoHatBib0FglicXISIl2ziaTibsA/640?wx_fmt=png)

第一步，我们编写一个 1 加到 100 的循环代码。

```
#include "stdafx.h"#include <stdlib.h>int main(int argc, char* argv[]){	int n = 1;	int nSum = 0;	while (n <= 100)	{		nSum = nSum + n;		n++;	} 		printf("%d", nSum);	system("pause");	return 0;}
```

第二步，分析 while 循环的代码定式。  
注意，该循环的 Debug 版本和 Release 版本存在差异，接下来会对比分析。我们先给出代码定式，如下所示。

```
//程序语言while(xxx){    ...}//代码定式WHILE_BEGIN:    jxx WHILE_END        ...    jmp WHILE_BEGINWHILE_END:    ...
```

while 循环的条件跳是往上跳的，它需要反复执行同一代码段。

第三步，通过 OD 打开运行的 EXE 程序 “RE_XH.exe”。

*   程序入口地址：0x00401260
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzzMEOeP0P9dMLpXc1UY8xSdia1QN9eU23ribeztmmuht64RHdGl5VtQHg/640?wx_fmt=png)

第四步，往下查找代码，发现 3 个 PUSH 后（参数）就是主函数，然后 F2 添加断点并 F7 步入主函数。

*   主函数：CALL RE_XH.00401005
    

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz0qicbkshu4Z1fUjaibib0mibAGYicib3XUoaicq9uQJo34beDEianeHUcvpdwg/640?wx_fmt=png)

第五步，分析汇编代码。  
这里存在一个 JG 跳转，它有点像 if 语句，下面还有一个 JMP，有点像 if-else 指令，但是它的跳转是地址减量跳或往上跳，所以它是循环。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzE0R07E2EiaIAlfQgMkml6zDx9jc1Gicq3Vqm9VSiczF5Xu3H8QsZ0hgCg/640?wx_fmt=png)

这时会发现 while 循环比刚才的多了一个跳转。我们会过计算机组成原理，当处理器执行跳转指令时，流水线会暂时挂起失效，本来流水线在取指令时已经准备预读后面的代码了，结果在译码过程中是个跳转，后面的代码预读就会出错，然后做流水线清理工作。所以，while 循环有两条对流水线的伤害比 do-while 大。

第六步，接着我们用高版本 VS2019 编译一个 Release 版本，并用 IDA 进行分析，看看高版本有什么优化。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzVfUkPyXudQCSHT9lonCLlo6V7LJkDvIEcyez1dQAAIzSE6tJPcxKeQ/640?wx_fmt=png)

查看 Text View，我们定位到 main 函数之后，看看它做的优化。它把循环的起点对齐到十六进制 10 的倍数地址，中间会用 nop 进行空指令填充。同时，它的汇编循环体变成了 do-while 循环。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzFKzWV1uENjzzOqvMyDPEdeDZXJRaVjeBMwqv7q2B2dNf7pZM2UIUnQ/640?wx_fmt=png)

注意，前面的 VC++ Debug 版本用 IDA 工具打开如下图所示。上图和下图同样都是 while 循环，但低版本可以看到 JG（往下跳）和 JMP（往上跳）两个跳转，典型的 while 循环；而高版本的却修改成了 do-while 循环的形式。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDznXSzJNZAOULxFDlbdL8N0zgVzlG6KCSzXC0IWTricaYnyR252oBQ2FA/640?wx_fmt=png)

问题 1：由于 do-while 循环会执行一次循环体，难道它不担心编译器出错吗？  
其实它比较的数值是常量，常量可以在编译期间预置其结果的，其实编译器在第一次的判断时先进行了一次常量传播，令 n 等于 1，即判断的是 while(1<=100)，比较 1 和 100 的关系条件必成立。  

问题 2：那么，如果将 100 替换成变量，编译器还能识别吗？或者会报错？  
此时的编译器会将其进行转换，变成如下图所示的形式再执行 do-while 循环。其中 if(n<=argc) 条件判断嵌套一个循环。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzccucWsP4MSTIibb79ut0T0V1o0zicyPqSp706N59rk72MyfIpibicsdbjA/640?wx_fmt=png)

对应的汇编代码如下，其中 “jl short loc_401016” 往下跳，还原成一个单分支，循环里面还有一个跳转 “jle short loc_40100F” 往上跳，满足 do-while 循环，最终还原成 if 加 do-while，或者你知道有这个优化，直接还原成带变量的 while 循环也可以。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzv4hicrqiaGvfjqGcFKiaHC8kUpJwicoXVicHwvYUlBaKF3BVk8gPYxeIicIA/640?wx_fmt=png)

但需要注意，能不能把 do-while 直接还原成 while 循环，还需要看看这两个条件有没有相关性。如果有相关性才能还原，比如外层判断是文件的打开状态，while 是迭代 n 值，这种情况不能还原。下图可以看到 if 和循环都是 EAX 参数比较，所以具有相关性。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz6rqX0Hylthia3SFeSSl3LCEqkOegURe1O6KQ8F5DVhib1yHeEJq7iaDKw/640?wx_fmt=png)

3.for 结构分析
----------

下面开始分析 for 循环结构。

```
for(表达式1;表达式2;表达式3;){	语句;}
```

第一步，我们编写一个 for 循环代码。

```
#include "stdafx.h"#include <stdlib.h>int main(int argc, char* argv[]){	int nSum = 0;	for (int n = 1; n<=argc; n++)	{		nSum = nSum + n;	} 		printf("%d", nSum);	system("pause");	return 0;}
```

第二步，编译生成新的 Debug 版可执行程序。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzwwZqyw63jJrjhuiaYibhqh6UukmjlWvORp97w3Wljy92cSv0plQaHMnQ/640?wx_fmt=png)

第三步，通过 IDA 打开运行的 EXE 程序 “RE_XH.exe”。  
产出了三个跳转代码，如下图所示。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzcg54y57pASP8yicmvibZjK6QGb2GhSMNiad61ibd8MMFicae8wlDk17J9aw/640?wx_fmt=png)

其代码定式如下所示，可以看到 JMP、JG 和 JMP 三个跳转。注意，for 循环中 FOR_STEP 地址是低于 BODY 执行体的地址的。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzof69vwPiaBnxsYtGEX36NHicibtcdYQkZ0PzbDicJ9s2amvLnlUQEic3vXA/640?wx_fmt=png)

第四步，分析汇编代码。  
首先 MOV 进行初始化赋值 1，接着 JMP 跳转到比较部分，比较不成立则 JG 直接跳出循环，否则执行循环体 BODY 内容，接着继续 JMP 跳转上去执行 n++ 操作。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzvKm4qa9E0QibSCHXGnrxY3L5Lv3VlnRgdy1qggBuX3FslUVNxCSfHFw/640?wx_fmt=png)

注意，由于 Release 版本都被编译器优化成了 do-while 循环，所以我们需要在 Debug 版下进行对比。

第五步，通过 VS2019 生成 Release 版本，然后用 IDA 打开代码对比。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzOe8MTAwABHJzDibiaib7t03b0cib6krzanZfPqoARJELf5ibtHUut5yEX5A/640?wx_fmt=png)

IDA 打开如下图所示，发现和 do-while 一样，高版本做了一点小处理，每次循环总次数增加了 4（add eax,4），从而提升效率。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzXJ8ULbL1paHBgFyzuV8rfFNSQIicD17aNRAqB4Wz7Kumnfu9kTdFQGg/640?wx_fmt=png)

三. 总结
=====

写到这里，这篇文章就介绍完毕，希望对您有所帮助，最后进行简单的总结下。

*   条件语句逆向分析
    
*   循环语句逆向分析
    

学安全一年，认识了很多安全大佬和朋友，希望大家一起进步。这篇文章中如果存在一些不足，还请海涵。作者作为网络安全初学者的慢慢成长路吧！希望未来能更透彻撰写相关文章。同时非常感谢参考文献中的安全大佬们的文章分享，深知自己很菜，得努力前行。

很多朋友问我如何学逆向分析？  
下面给出推荐的学习路线和安全书籍。软件逆行其实就是搬砖活，你需要的是任性和基本功。可能大佬们会有很多技巧，但我希望你能扎扎实实去躺过那些坑，会看懂代码，会写代码，然后 IDA 和 OD 工具（倚天屠龙）用好，每天泡在代码中，肯定能行的。你应该这样学习：

*   1. 多敲代码，重视实战；
    
*   2. 程序不是写出来的，是调出来的；
    
*   3. 根据自己兴趣和市场需求做一定规模的项目。
    

下图开发和逆向项目非常推荐你去完成，开发远控软件有助于你分析木马，CAD 软件能提升你 C++ 分析能力，做一个调制器或许反调试就不再那么难，自制一个小操作系统、小编译器、任务管理器，或许逆向原理就懂了。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDz51tSXMfCyRVPSaejMiawsMgiaSlGiadZiamRiaAgZX6Ur2B62huf2kRUplQ/640?wx_fmt=png)

最后给出了这一年我在网络安全、系统安全和机器学习看过的书，如果你想把 AI 更好的融入安全领域，看看这些书籍还是挺不错，我也厚着脸皮把自己写的两本 Python 数据分析书放了进来，哈哈~

网络安全：  
![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzYwZICFhVKrMmqickX7O1fs97vWnzQOIqTADID9pEBFPTkBdOdwgzeBg/640?wx_fmt=png)

系统安全：

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzmvMSgP6GwvPMJlDSvcVfCwt3wVy8RLy1rrKAR0Jm34tobpibzK2S2YA/640?wx_fmt=png)

AI + 安全：

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROj5x1RVneBkMT6j9UXrpDzTibEPsvlpTHUXrGapGceiaaJEBIlcevs1DiaH5T6Q0savsrQVsIaFIYibA/640?wx_fmt=png)

编程没有捷径，逆向也没有捷径，它们都是搬砖活，少琢磨技巧，干就对了。什么时候你把攻击对手按在地上摩擦，你就赢了，也会慢慢形成了自己的安全经验和技巧。加油吧，少年希望这个路线对你有所帮助，共勉。

2020 年 8 月 18 新开的 “娜璋 AI 安全之家”，主要围绕 Python 大数据分析、网络空间安全、人工智能、Web 渗透及攻防技术进行讲解，同时分享 CCF、SCI、南核北核论文的算法实现。娜璋之家会更加系统，并重构作者的所有文章，从零讲解 Python 和安全，写了近十年文章，真心想把自己所学所感所做分享出来，还请各位多多指教，真诚邀请您的关注！谢谢。

![](https://mmbiz.qpic.cn/mmbiz_png/0RFmxdZEDROZePZ27y7oibNu4BGibRAq4HydK4JWeQXtQMKibpFEkxNKClkDoicWRC06FHBp99ePyoKPGkOdPDezhg/640?wx_fmt=png)

前文回顾（链接可以）：

*   [[系统安全] 一. 什么是逆向分析、逆向分析应用及经典扫雷游戏逆向](http://mp.weixin.qq.com/s?__biz=Mzg5MTM5ODU2Mg==&mid=2247484670&idx=1&sn=c31b15b73f27a7ce44ae1350e7f708a2&chksm=cfccb433f8bb3d25c25f044caac29d358fe686602011d8e4cbdc504e3a587e756215ce051819&scene=21#wechat_redirect)
    
*   [[系统安全] 二. 如何学好逆向分析及吕布传游戏逆向案例](http://mp.weixin.qq.com/s?__biz=Mzg5MTM5ODU2Mg==&mid=2247484756&idx=1&sn=ef95ff95474c51fa2bd4b9b4847ebb54&chksm=cfccb599f8bb3c8fa4852416cff6695fc8dcc9aadb3295c7249c12c03cad4c146a93e6250d56&scene=21#wechat_redirect)
    
*   [[系统安全] 三. IDA Pro 反汇编工具初识及逆向工程解密实战](http://mp.weixin.qq.com/s?__biz=Mzg5MTM5ODU2Mg==&mid=2247484812&idx=1&sn=9b77853a5b9da0f7a688e592dba3ddba&chksm=cfccb541f8bb3c57faffc7661a452238debe09cc7a57ae2d9e9d835d6520ee441bfd9d5ad119&scene=21#wechat_redirect)
    
*   [[系统安全] 四. OllyDbg 动态分析工具基础用法及 Crakeme 逆向破解](http://mp.weixin.qq.com/s?__biz=Mzg5MTM5ODU2Mg==&mid=2247484950&idx=1&sn=07d8f0b20f599586ef06035354b14630&chksm=cfccb6dbf8bb3fcd6d2efcc7b6757fabd8015d86f43e3bc8ae6cb9367d19492aec881374fca2&scene=21#wechat_redirect)
    
*   [[系统安全] 五. OllyDbg 和 Cheat Engine 工具逆向分析植物大战僵尸游戏](http://mp.weixin.qq.com/s?__biz=Mzg5MTM5ODU2Mg==&mid=2247485043&idx=1&sn=028c702990f722d087c6c349fb34f5fb&chksm=cfccb6bef8bb3fa8882994f7412db6b769d382abbafa6b5b3bd1b5ae62dffa20e81c7170ecb4&scene=21#wechat_redirect)
    
*   [系统安全] 六. 逆向分析之条件语句和循环语句源码还原及流程控制
    

参考资料：  
真心推荐大家好好看看这些视频和文章，感恩这些大佬！前非常推荐钱老师的视频，感谢华科 UP 主。  
[1] 科锐逆向的钱林松老师受华中科技大学邀请 - “逆向分析计算引导”  
[2] C 语言逆向工程之游戏辅助开发 - C 语言 Plus  
[3] https://www.bilibili.com/video/BV1J5411x7qz?p=1